package com.sf.javase.day09.homework.lianxi.impl;

import com.sf.javase.day09.homework.lianxi.ShapeInterface;

/**
 * 矩形类
 */
public class Rectangle implements ShapeInterface {
    private Double length;  //长
    private Double wide;  //宽

    public Rectangle() {
    }

    public Rectangle(Double length, Double wide) {
        this.length = length;
        this.wide = wide;
    }

    public Double getLength() {
        return length;
    }

    public void setLength(Double length) {
        this.length = length;
    }

    public Double getWide() {
        return wide;
    }

    public void setWide(Double wide) {
        this.wide = wide;
    }

    @Override
    public Double getArea() {
        return length*wide;
    }

    @Override
    public Double getPerimeter() {
        return (wide+length)*2;
    }

    @Override
    public String display() {
        return "周长是 = "+getPerimeter()+", 面积是 = "+getArea();
    }

    @Override
    public int compareToArea(ShapeInterface s1, ShapeInterface s2) {
        if(s1.getArea() > s2.getArea()){
            System.out.println("第一个面积大于第二个面积");
            return 1;
        }else if (s1.getArea() == s2.getArea()){
            System.out.println("第一个面积等于第二个面积");
            return 0;
        }else {
            System.out.println("第一个面积小于第二个面积");
            return -1;
        }
    }

    @Override
    public int compareToPerimeter(ShapeInterface s1, ShapeInterface s2) {
        if(s1.getPerimeter() > s2.getPerimeter()){
            System.out.println("第一个周长大于第二个周长");
            return 1;
        }else if (s1.getPerimeter() == s2.getPerimeter()){
            System.out.println("第一个周长等于第二个周长");
            return 0;
        }else {
            System.out.println("第一个周长小于第二个周长");
            return -1;
        }
    }


    public static void main(String[] args) {
        ShapeInterface shapeInterface1 = new Rectangle(3.0,4.0);
        System.out.println(shapeInterface1.display());
        ShapeInterface shapeInterface2 = new Rectangle(4.0,4.0);
        shapeInterface1.compareToArea(shapeInterface1,shapeInterface2);
        shapeInterface1.compareToPerimeter(shapeInterface1,shapeInterface2);
    }
}
