package com.sf.jdbc.day25;

import com.alibaba.druid.pool.DruidDataSource;
import com.alibaba.druid.pool.DruidDataSourceFactory;
import org.junit.jupiter.api.Test;

import javax.sql.DataSource;
import java.io.InputStream;
import java.sql.*;
import java.util.Properties;

/**
 * jdbc - day02
 */
public class TE {
    @Test
    public void t1() throws ClassNotFoundException, SQLException {
        Class.forName("com.mysql.jdbc.Driver");
        Connection connection = DriverManager.getConnection("jdbc:mysql://localhost:3306/jdbc?characterEncoding=utf-8", "root", "root");
        PreparedStatement preparedStatement = connection.prepareStatement("INSERT INTO user(user_name,price,create_time) values (?,?,?)");
        preparedStatement.setString(1,"lisa");
        preparedStatement.setDouble(2,123.12);
        preparedStatement.setDate(3,new Date(System.currentTimeMillis()));
        int i = preparedStatement.executeUpdate();
//        int a = 1/0;    ///  出现问题
        System.out.println(i);
    }

    /**
     * z3给l4转账500元
     */
    @Test
    public void t2(){
        Connection connection  = null;
        //加载驱动
        try {
            Class.forName("com.mysql.jdbc.Driver");
            //获取连接
             connection = DriverManager.getConnection("jdbc:mysql://localhost:3306/jdbc?characterEncoding=utf-8", "root", "root");
            //取消数据库的默认提交方式
            connection.setAutoCommit(false);
            //创建statement对象
            Statement statement = connection.createStatement();
            String sql1 = "UPDATE account SET money = money - 500 WHERE account_name='z3' ";
            String sql2 = "UPDATE account SET money = money + 500 WHERE account_name='l4' ";
            int row1 = statement.executeUpdate(sql1);
//            int a  = 1/0;
            int row2 = statement.executeUpdate(sql2);
            System.out.println(row1);
            System.out.println(row2);
            //  手动提交
            connection.commit();
        } catch (ClassNotFoundException | SQLException e) {
              if(connection != null){
                  try {
                      connection.rollback();
                  } catch (SQLException ex) {
                      ex.printStackTrace();
                  }
              }
            e.printStackTrace();
            System.out.println("connection is null");
        }
    }

    /**
     * druid
     */
    @Test
    public void t3() throws SQLException {
        ////创建Druid的核心连接池对象DruidDataSource
        DruidDataSource ds = new DruidDataSource();
        ds.setUrl("jdbc:mysql://localhost:3306/jdbc?characterEncoding=utf-8");
        ds.setUsername("root");
        ds.setPassword("root");
        ds.setDriverClassName("com.mysql.jdbc.Driver");
        Connection connection = ds.getConnection();
        String sql  = "INSERT INTO  user(user_name,price,create_time) values (?,?,?)";
        PreparedStatement preparedStatement = connection.prepareStatement(sql);
        preparedStatement.setString(1,"zzxx");
        preparedStatement.setDouble(2,123.31);
        preparedStatement.setDate(3,new Date(System.currentTimeMillis()));
        int row = preparedStatement.executeUpdate();
        System.out.println(row);
    }

    /**
     * 使用DruidDataSourceFactory工厂类获取DruidDataSource对象
     * @throws SQLException
     */
    @Test
    public void t4() throws Exception {
      //加载外部配置文件
        InputStream in = TE.class.getClassLoader().getResourceAsStream("db.properties");
        Properties p = new Properties();
        p.load(in);
        DataSource dataSource = DruidDataSourceFactory.createDataSource(p);
        Connection connection = dataSource.getConnection();
        //......
        String sql  = "INSERT INTO  user(user_name,price,create_time) values (?,?,?)";
        PreparedStatement preparedStatement = connection.prepareStatement(sql);
        preparedStatement.setString(1,"ccvv");
        preparedStatement.setDouble(2,123.31);
        preparedStatement.setDate(3,new Date(System.currentTimeMillis()));
        int row = preparedStatement.executeUpdate();
        System.out.println(row);
    }
}
